#ifndef HASH__H
#define HASH__H

#include <containers/vec_.h>
#include <types.h>
#include "pair_.h"

typedef bool (*keys_equ_f)(void* key1, void* key2);

typedef struct {
	Vec		pairs;
	keys_equ_f	keys_equ;
	size_t		keysize;
	size_t		valuesize;
} Hash_;

Hash_* hash_New(size_t keysize, size_t valuesize, keys_equ_f keys_equ);
void hash_Delete(Hash_* hash);
void hash_Construct(Hash_* hash, size_t keysize, size_t valuesize, keys_equ_f keys_equ);
void hash_Destroy(Hash_* hash);
void hash_Insert(Hash_* hash, void* key, void* value);
uint32_t hash_GetNumKeys(Hash_* hash);
Pair_* hash_GetPair(Hash_* hash, uint32_t i);

#endif	/* HASH__H */

