#ifndef TREE_H
#define TREE_H

#include <containers/stack.h>
#include <containers/vec_.h>
#include <types.h>

typedef struct TreeNode {
	void*	data;
	struct	TreeNode* parent;
	Vec	children;
} TreeNode;

void init_TreeNode( TreeNode* self, void* data );
void destroy_TreeNode( TreeNode* self );
void attachChild_TreeNode( TreeNode* self, TreeNode* child );
uint_t getNumChildren_TreeNode( const TreeNode* self );
TreeNode* getParent_TreeNode( const TreeNode* self );
TreeNode* getChild_TreeNode( const TreeNode* self, uint_t i );
void* getData_TreeNode( const TreeNode* self );

typedef struct {
	Stack		stack;
	TreeNode*	node;
	TreeNode*	next;
	uint_t		i;
} TreeNodeIterator;

void init_TreeNodeIterator( TreeNodeIterator* self );
void destroy_TreeNodeIterator( TreeNodeIterator* self );
TreeNode* inc_TreeNodeIterator( TreeNodeIterator* self );
void reset_TreeNodeIterator( TreeNodeIterator* self, TreeNode* node );

#endif	/* TREE_H */

