#ifndef DLTRANS_H
#define DLTRANS_H

#include <containers/vec_.h>
#include <math/vector.h>
#include <sys/dlist.h>
#include <sys/nativedl.h>
#include <sys/surface.h>
#include <texture.h>
#include <types.h>

typedef struct {
	Vec		rspMatrices;
	Vec		vtxBuffer;
	uint32_t*	idxBuffer;
	uint8_t		vtxFormat;
	const void*	vtxSource;
	const void*	idxSource;
	float		scale;
	Surface		surfColor;
	Surface		surfZ;
	Vector4f	clearColor;
	float		clearZVal;
	const Texture*	tex;
	Material	material;
} DLTrans;

void init_DLTrans( DLTrans* dltrans );
void destroy_DLTrans( DLTrans* dltrans );
void process_DLTrans( DLTrans* dltrans, const DList* dl_in, NativeDL* dl_out );

#endif	/* DLTRANS_H */

