#include "vector.h"

float sqrtf( float );

inline void init_Vector2f( Vector2f* self, float x, float y ) {
	self->x = x;
	self->y = y;
}

inline void init_Vector3f( Vector3f* self, float x, float y, float z ) {
	self->x = x;
	self->y = y;
	self->z = z;
}

inline void init_Vector4f( Vector4f* self, float x, float y, float z, float t ) {
	self->x = x;
	self->y = y;
	self->z = z;
	self->t = t;
}

inline void saturatedAdd_Vector3f( Vector3f* out, const Vector3f* u, const Vector3f* v ) {
	out->x = u->x + v->x;
	out->y = u->y + v->y;
	out->z = u->z + v->z;

	if( out->x > 1.0f ) {
		out->x = 1.0f;
	}
	if( out->y > 1.0f ) {
		out->y = 1.0f;
	}
	if( out->z > 1.0f ) {
		out->z = 1.0f;
	}
}

inline void sub_Vector3f( Vector3f* result, const Vector3f* u, const Vector3f* v ) {
	result->x = u->x - v->x;
	result->y = u->y - v->y;
	result->z = u->z - v->z;
}

inline float length_Vector3f( const Vector3f* v ) {
	return sqrtf( v->x * v->x + v->y * v->y + v->z * v->z );
}

inline void normalize_Vector3f( Vector3f* result, const Vector3f* v ) {
	float l = length_Vector3f( v );
	if( 0 == l ) {
		return;
	}

	result->x = v->x / l;
	result->y = v->y / l;
	result->z = v->z / l;
}

