#ifndef VECTOR_H
#define VECTOR_H

typedef struct {
	float	x;
	float	y;
} Vector2f;

typedef struct {
	float	x;
	float	y;
	float	z;
} Vector3f;

typedef struct {
	float	x;
	float	y;
	float	z;
	float	t;
} Vector4f;

#define VECTOR2F_SET(a,b)	\
{.x = a, .y = b}
#define VECTOR3F_SET(a,b,c) \
{.x = a, .y = b, .z = c}

void init_Vector2f( Vector2f* self, float x, float y );
void init_Vector3f( Vector3f* self, float x, float y, float z );
void init_Vector4f( Vector4f* self, float x, float y, float z, float t );

void sub_Vector3f( Vector3f* result, const Vector3f* u, const Vector3f* v );
void saturatedAdd_Vector3f( Vector3f* out, const Vector3f* u, const Vector3f* v );
float length_Vector3f( const Vector3f* v );
void normalize_Vector3f( Vector3f* result, const Vector3f* v );

#endif	/* VECTOR_H */

