#include <sys/region.h>
#include "mesh.h"

void init_Mesh( Mesh* self, const Pair* pairs ) {
	init_Vec( &self->vpairs, sizeof(Pair), ALIGN_DEFAULT );
	init_Vec( &self->layers, sizeof(Layer), ALIGN_DEFAULT );

	if( NULL == pairs ) {
		return;
	}

	for( const Pair* pair = pairs; pair->mat; pair++ ) {
		pushBack_Vec( &self->vpairs, pair );
	}
}

void destroy_Mesh( Mesh* self ) {
	destroy_Vec( &self->layers );
	destroy_Vec( &self->vpairs );
}

