#ifndef XFORMER_H
#define XFORMER_H

#include <math/matrix.h>
#include "coordsys.h"

struct Xformer;
typedef void (*ProcessFunc_Xformer)( struct Xformer*, void* data );

typedef struct {
	ProcessFunc_Xformer	processor;
	Matrix*			resultMtx;
	Matrix			mtx;
	Coordsys		csys;
} Xformer;

void init_Xformer( Xformer* self, ProcessFunc_Xformer processor );
void destroy_Xformer( Xformer* self );
void reset_Xformer( Xformer* self );
void process_Xformer( Xformer* self, void* data );
Matrix* getMatrix_Xformer( Xformer* self );
Matrix* getResultMatrix_Xformer( const Xformer* self );
const Coordsys* getCoordsys_Xformer( const Xformer* self );
void transformLocally_Xformer( Xformer* self, Matrix* mtx );
void finish_Xformer( Xformer* xf, Xformer* parent_xf,
	Matrix* resultMtx );

#endif	/* XFORMER_H */

