#include <ultra64.h>
#include <sys/sys.h>
#include <types.h>
#include "postproc.h"

#define KERNEL_SIZE (5*5)
#define ble(x) (((x) << 11) | ((x) << 6) | ((x) << 1) | 1)
#if 0
static uint16_t kernel_u16[KERNEL_SIZE] = {			// align this
	ble(1), ble(1), ble(1), ble(1), ble(1),
	ble(1), ble(1), ble(1), ble(1), ble(1),
	ble(1), ble(1), ble(1), ble(1), ble(1),
	ble(1), ble(1), ble(1), ble(1), ble(1),
	ble(1), ble(1), ble(1), ble(1), ble(1),
};
#endif
#if 0
static Gfx glist[4096];

static uint16_t blur_out[KERNEL_SIZE];

void postprocBlur_RGBA_5551_RDP(const Surface* surface_out, const Surface* surface) {

	Gfx* gp = glist;
	gDPLoadSync(gp++);
	gDPSetPrimColor(gp++, 0, 0, 255, 0, 0, 255);

	uint16_t* dst = surfaceGetData(surface_out);
	uint32_t i = surfaceGetPixelsNum(surface_out);
	while(i--) {
		// go RDP!
		gDPSetTextureImage(

		if(sysIsRendering()) {
			sysWaitForGPU();
		}

		uint32_t r,g,b;
		uint16_t col;
		r = g = b = 0;
		for(int i=0; i<KERNEL_SIZE; ++i) {
			col = blur_out[i];
			r += col & (0x1F << 11);
			g += col & (0x1F << 6);
			b += col & (0x1F << 1);
		}
		*dst++ = ((r/KERNEL_SIZE) & (0x1F << 11)) | ((g/KERNEL_SIZE) & (0x1F << 6)) | ((b/KERNEL_SIZE) & (0x1F << 1)) | 0x1;
	}
}
#endif

static float k[] = {
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 0.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24,
	1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24, 1.0f/24
};

void postprocBlur_RGBA_5551(const Surface* surface_out, const Surface* surface) {
	int32_t i;
	static uint16_t pr[25];
	static uint16_t pg[25];
	static uint16_t pb[25];
	static uint16_t pa[25];
	uint16_t r,g,b,a;
	float fr,fg,fb,fa;

	uint16_t* buf = getData_Surface( surface );
	uint16_t* buf_o = getData_Surface( surface_out );
	uint16_t width = getWidth_Surface( surface );
	uint16_t c;
	
	for(uint32_t n=0; n< getPixelsNum_Surface( surface ); n++) {
		uint32_t ofs = n - (width<<1);	// start 2 lines above current pix
		uint32_t j = 0; //n%5;

		c = buf[ofs];
		pr[j] = (c&0xF800) >> 4;
		pg[j] = (c&0x07C0) >> 4;
		pb[j] = (c&0x003E) >> 4;
		pa[j] = (c&0x0001) >> 4;
		j+=5;
		ofs += width;
		
		c = buf[ofs];
		pr[j] = (c&0xF800) >> 4;
		pg[j] = (c&0x07C0) >> 4;
		pb[j] = (c&0x003E) >> 4;
		pa[j] = (c&0x0001) >> 4;
		j+=5;
		ofs += width;
		
		c = buf[ofs];
		pr[j] = (c&0xF800) >> 4;
		pg[j] = (c&0x07C0) >> 4;
		pb[j] = (c&0x003E) >> 4;
		pa[j] = (c&0x0001) >> 4;
		j+=5;
		ofs += width;
		
		c = buf[ofs];
		pr[j] = (c&0xF800) >> 4;
		pg[j] = (c&0x07C0) >> 4;
		pb[j] = (c&0x003E) >> 4;
		pa[j] = (c&0x0001) >> 4;
		j+=5;
		ofs += width;
		
		c = buf[ofs];
		pr[j] = (c&0xF800) >> 4;
		pg[j] = (c&0x07C0) >> 4;
		pb[j] = (c&0x003E) >> 4;
		pa[j] = (c&0x0001) >> 4;
		j+=5;
		ofs += width;
		
		for(i=0, fr=fg=fb=fa=0.0f; i<25; i+=5) {
			fr += pr[i];	//k[i];
			fg += pg[i];	//k[i];
			fb += pb[i];	//k[i];
			fa += pa[i];	//k[i];
		}
		
		r = ((uint16_t)fr)&0xF800;
		g = ((uint16_t)fg)&0x07C0;
		b = ((uint16_t)fb)&0x003E;
		a = ((uint16_t)fa)&0x0001;
		
		((uint16_t*)buf_o)[n] = r|g|b|a;
	}
}

void postprocBlur_RGBA_5551_float(const Surface* surface_out, const Surface* surface) {
	int32_t i;
	uint16_t j;
	static uint16_t p[25];
	static uint16_t pr[25];
	static uint16_t pg[25];
	static uint16_t pb[25];
	static uint16_t pa[25];
	uint16_t r,g,b,a;
	float fr,fg,fb,fa;

	uint16_t* buf = getData_Surface( surface );
	uint16_t* buf_o = getData_Surface( surface_out );
	uint16_t width = getWidth_Surface( surface );
	
	for(uint32_t n=0; n<getPixelsNum_Surface( surface ); n++) {
		uint32_t ofs = n - (width<<1);
		for(i=-2, j=0; i<=2; i++) {
			p[j] = buf[ofs-2];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs-1];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs+1];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;
			
			p[j] = buf[ofs+2];
			pr[j] = p[j]&0xF800;
			pg[j] = p[j]&0x07C0;
			pb[j] = p[j]&0x003E;
			pa[j] = p[j]&0x0001;
			j++;

			ofs += width;
		}
		
		for(i=0, fr=fg=fb=fa=0.0f; i<25; i++) {
			fr += pr[i]*k[i];
			fg += pg[i]*k[i];
			fb += pb[i]*k[i];
			fa += pa[i]*k[i];
		}
		
		r = ((uint16_t)fr)&0xF800;
		g = ((uint16_t)fg)&0x07C0;
		b = ((uint16_t)fb)&0x003E;
		a = ((uint16_t)fa)&0x0001;
		
		((uint16_t*)buf_o)[n] = r|g|b|a;
	}
}

void postprocBlur(const Surface* surface_out, const Surface* surface) {
	switch(getPixelFormat_Surface( surface )) {
		default:
			postprocBlur_RGBA_5551(surface_out, surface);
			break;
	}
}

void postprocMix_RGBA_5551(const Surface* surface_out, const Surface* surface_a, const Surface* surface_b) {
	if(surface_out) {}
	if(surface_a) {}
	if(surface_b) {}
}

void postprocMix(const Surface* surface_out, const Surface* surface_a, const Surface* surface_b) {
	
	switch(getPixelFormat_Surface( surface_out )) {
		default:
			postprocMix_RGBA_5551(surface_out, surface_a, surface_b);
			break;
	}
}

