#ifndef SYS_H
#define SYS_H

#include <types.h>
#include "nativedl.h"
#include "dlist.h"
#include "surface.h"
#include "time.h"

#define	BUFFER_W	320			/*  */
#define	BUFFER_H	240			/*  */

typedef enum {
	BUFFER_COLOR_DRAW,
	BUFFER_COLOR_DISPLAY,
	BUFFER_COLOR_0,
	BUFFER_COLOR_1,
	BUFFER_Z,
	BUFFER_AUX
} BufferType;

typedef enum {
	HANDLER_VBI,
	HANDLER_CONTROLLER
} HandlerType;

typedef struct {
	uint16_t	width;
	uint16_t	height;
} GfxMode;

int		init_Sys( void );
void		waitForGPU_Sys( void );
void		waitForVBI_Sys( void );
void		runGPU_Sys( const DList* dlist );
void		swapBuffers_Sys( void );
const Surface*	getBuffer_Sys( BufferType type );
NativeDL*	getNativeDL_Sys( void );
void		raiseError_Sys( void );
void		registerHandler_Sys( HandlerType type, void (*handler)(void*) );
bool		isRendering_Sys( void );
void*		getHiMem_Sys( void );
Time		getTime_Sys( void );
void		setAudioSource_Sys( const void* src );
void 		setAudioFrequency_Sys( uint32_t frequency );

#endif

