#include "time.h"

inline Time calcDuration_Time( const Time* t0, const Time* t1) {
	Time dur = {
		t1->sec - t0->sec,
		t1->msec - t0->msec,
		t1->nsec - t0->nsec
	};

	return dur;
}

TimeRelation compare_Time( const Time* t0, const Time* t1 ) {
	Time dur = calcDuration_Time( t0, t1 );
	int64_t val = dur.nsec + dur.msec * 1000 + dur.sec * 1000000;

	if( 0 == val ) {
		return TIME_EQUAL;
	}

	return val>0 ? TIME_LESS : TIME_GREATER;
}

